/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  PayableOverrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface IL1StakingBaseInterface extends ethers.utils.Interface {
  functions: {
    "setL1GraphTokenLockTransferTool(address)": FunctionFragment;
    "transferDelegationToL2(address,address,uint256,uint256,uint256)": FunctionFragment;
    "transferLockedDelegationToL2(address,uint256,uint256,uint256)": FunctionFragment;
    "transferLockedStakeToL2(uint256,uint256,uint256,uint256)": FunctionFragment;
    "transferStakeToL2(address,uint256,uint256,uint256,uint256)": FunctionFragment;
    "unlockDelegationToTransferredIndexer(address)": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "setL1GraphTokenLockTransferTool",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "transferDelegationToL2",
    values: [string, string, BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "transferLockedDelegationToL2",
    values: [string, BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "transferLockedStakeToL2",
    values: [BigNumberish, BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "transferStakeToL2",
    values: [string, BigNumberish, BigNumberish, BigNumberish, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "unlockDelegationToTransferredIndexer",
    values: [string]
  ): string;

  decodeFunctionResult(
    functionFragment: "setL1GraphTokenLockTransferTool",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferDelegationToL2",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferLockedDelegationToL2",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferLockedStakeToL2",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferStakeToL2",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "unlockDelegationToTransferredIndexer",
    data: BytesLike
  ): Result;

  events: {
    "DelegationTransferredToL2(address,address,address,address,uint256)": EventFragment;
    "IndexerStakeTransferredToL2(address,address,uint256)": EventFragment;
    "L1GraphTokenLockTransferToolSet(address)": EventFragment;
    "StakeDelegatedUnlockedDueToL2Transfer(address,address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "DelegationTransferredToL2"): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "IndexerStakeTransferredToL2"
  ): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "L1GraphTokenLockTransferToolSet"
  ): EventFragment;
  getEvent(
    nameOrSignatureOrTopic: "StakeDelegatedUnlockedDueToL2Transfer"
  ): EventFragment;
}

export type DelegationTransferredToL2Event = TypedEvent<
  [string, string, string, string, BigNumber] & {
    delegator: string;
    l2Delegator: string;
    indexer: string;
    l2Indexer: string;
    transferredDelegationTokens: BigNumber;
  }
>;

export type IndexerStakeTransferredToL2Event = TypedEvent<
  [string, string, BigNumber] & {
    indexer: string;
    l2Indexer: string;
    transferredStakeTokens: BigNumber;
  }
>;

export type L1GraphTokenLockTransferToolSetEvent = TypedEvent<
  [string] & { l1GraphTokenLockTransferTool: string }
>;

export type StakeDelegatedUnlockedDueToL2TransferEvent = TypedEvent<
  [string, string] & { indexer: string; delegator: string }
>;

export class IL1StakingBase extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: IL1StakingBaseInterface;

  functions: {
    setL1GraphTokenLockTransferTool(
      _l1GraphTokenLockTransferTool: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    transferDelegationToL2(
      _indexer: string,
      _l2Beneficiary: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    transferLockedDelegationToL2(
      _indexer: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    transferLockedStakeToL2(
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    transferStakeToL2(
      _l2Beneficiary: string,
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    unlockDelegationToTransferredIndexer(
      _indexer: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;
  };

  setL1GraphTokenLockTransferTool(
    _l1GraphTokenLockTransferTool: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  transferDelegationToL2(
    _indexer: string,
    _l2Beneficiary: string,
    _maxGas: BigNumberish,
    _gasPriceBid: BigNumberish,
    _maxSubmissionCost: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  transferLockedDelegationToL2(
    _indexer: string,
    _maxGas: BigNumberish,
    _gasPriceBid: BigNumberish,
    _maxSubmissionCost: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  transferLockedStakeToL2(
    _amount: BigNumberish,
    _maxGas: BigNumberish,
    _gasPriceBid: BigNumberish,
    _maxSubmissionCost: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  transferStakeToL2(
    _l2Beneficiary: string,
    _amount: BigNumberish,
    _maxGas: BigNumberish,
    _gasPriceBid: BigNumberish,
    _maxSubmissionCost: BigNumberish,
    overrides?: PayableOverrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  unlockDelegationToTransferredIndexer(
    _indexer: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    setL1GraphTokenLockTransferTool(
      _l1GraphTokenLockTransferTool: string,
      overrides?: CallOverrides
    ): Promise<void>;

    transferDelegationToL2(
      _indexer: string,
      _l2Beneficiary: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    transferLockedDelegationToL2(
      _indexer: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    transferLockedStakeToL2(
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    transferStakeToL2(
      _l2Beneficiary: string,
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    unlockDelegationToTransferredIndexer(
      _indexer: string,
      overrides?: CallOverrides
    ): Promise<void>;
  };

  filters: {
    "DelegationTransferredToL2(address,address,address,address,uint256)"(
      delegator?: string | null,
      l2Delegator?: string | null,
      indexer?: string | null,
      l2Indexer?: null,
      transferredDelegationTokens?: null
    ): TypedEventFilter<
      [string, string, string, string, BigNumber],
      {
        delegator: string;
        l2Delegator: string;
        indexer: string;
        l2Indexer: string;
        transferredDelegationTokens: BigNumber;
      }
    >;

    DelegationTransferredToL2(
      delegator?: string | null,
      l2Delegator?: string | null,
      indexer?: string | null,
      l2Indexer?: null,
      transferredDelegationTokens?: null
    ): TypedEventFilter<
      [string, string, string, string, BigNumber],
      {
        delegator: string;
        l2Delegator: string;
        indexer: string;
        l2Indexer: string;
        transferredDelegationTokens: BigNumber;
      }
    >;

    "IndexerStakeTransferredToL2(address,address,uint256)"(
      indexer?: string | null,
      l2Indexer?: string | null,
      transferredStakeTokens?: null
    ): TypedEventFilter<
      [string, string, BigNumber],
      { indexer: string; l2Indexer: string; transferredStakeTokens: BigNumber }
    >;

    IndexerStakeTransferredToL2(
      indexer?: string | null,
      l2Indexer?: string | null,
      transferredStakeTokens?: null
    ): TypedEventFilter<
      [string, string, BigNumber],
      { indexer: string; l2Indexer: string; transferredStakeTokens: BigNumber }
    >;

    "L1GraphTokenLockTransferToolSet(address)"(
      l1GraphTokenLockTransferTool?: null
    ): TypedEventFilter<[string], { l1GraphTokenLockTransferTool: string }>;

    L1GraphTokenLockTransferToolSet(
      l1GraphTokenLockTransferTool?: null
    ): TypedEventFilter<[string], { l1GraphTokenLockTransferTool: string }>;

    "StakeDelegatedUnlockedDueToL2Transfer(address,address)"(
      indexer?: string | null,
      delegator?: string | null
    ): TypedEventFilter<
      [string, string],
      { indexer: string; delegator: string }
    >;

    StakeDelegatedUnlockedDueToL2Transfer(
      indexer?: string | null,
      delegator?: string | null
    ): TypedEventFilter<
      [string, string],
      { indexer: string; delegator: string }
    >;
  };

  estimateGas: {
    setL1GraphTokenLockTransferTool(
      _l1GraphTokenLockTransferTool: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    transferDelegationToL2(
      _indexer: string,
      _l2Beneficiary: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    transferLockedDelegationToL2(
      _indexer: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    transferLockedStakeToL2(
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    transferStakeToL2(
      _l2Beneficiary: string,
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    unlockDelegationToTransferredIndexer(
      _indexer: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    setL1GraphTokenLockTransferTool(
      _l1GraphTokenLockTransferTool: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    transferDelegationToL2(
      _indexer: string,
      _l2Beneficiary: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    transferLockedDelegationToL2(
      _indexer: string,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    transferLockedStakeToL2(
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    transferStakeToL2(
      _l2Beneficiary: string,
      _amount: BigNumberish,
      _maxGas: BigNumberish,
      _gasPriceBid: BigNumberish,
      _maxSubmissionCost: BigNumberish,
      overrides?: PayableOverrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    unlockDelegationToTransferredIndexer(
      _indexer: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;
  };
}
