#!ts-node
"use strict";
// Accepts a CSV file: field1 name, field2 Ethereum address
// Validates the address is valid, trims and exit on error
// Outputs a json in the format used by the distribution script
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.teamAddresses = void 0;
const fs_1 = __importDefault(require("fs"));
const ethers_1 = require("ethers");
const { getAddress } = ethers_1.utils;
exports.teamAddresses = [];
function main() {
    const data = fs_1.default.readFileSync('indexers.csv', 'utf8');
    const entries = data.split('\n').map(e => e.trim());
    for (const entry of entries) {
        if (!entry)
            continue;
        const [name, address] = entry.split(',').map(e => e.trim());
        // Verify address
        try {
            getAddress(address.trim());
        }
        catch (_) {
            console.log('Invalid', name, address);
            process.exit(1);
        }
        // Add to member list
        const member = {
            name,
            address,
        };
        exports.teamAddresses.push(member);
    }
    // Out
    console.log(JSON.stringify(exports.teamAddresses));
}
main();
