"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ethers_1 = require("ethers");
const hardhat_1 = __importDefault(require("hardhat"));
async function main() {
    const graph = hardhat_1.default.graph();
    const arbitratorPrivateKey = process.env.ARBITRATOR_PRIVATE_KEY;
    const arbitrator = new ethers_1.Wallet(arbitratorPrivateKey, graph.provider);
    console.log('Arbitrator:', arbitrator.address);
    const disputeId = '0x35e6e68aa71ee59cb710d8005563d63d644f11f2eee879eca9bc22f523c9fade';
    console.log('Dispute ID:', disputeId);
    // Accept dispute
    await graph.contracts.DisputeManager.connect(arbitrator).acceptDispute(disputeId);
}
main().catch((error) => {
    console.error(error);
    process.exitCode = 1;
});
