"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sdk_1 = require("@graphprotocol/sdk");
const gre_1 = require("@graphprotocol/sdk/gre");
(0, gre_1.greTask)('migrate', 'Deploy protocol contracts')
    .addFlag('skipConfirmation', 'Skip confirmation prompt on write actions')
    .addFlag('skipPostDeploy', 'Skip accepting ownership and unpausing protocol after deploying')
    .addFlag('force', 'Deploy contract even if its already deployed')
    .addFlag('buildAcceptTx', '...')
    .setAction(async (taskArgs, hre) => {
    const graph = hre.graph(taskArgs);
    await (0, sdk_1.deployGraphNetwork)(taskArgs.addressBook, taskArgs.graphConfig, graph.chainId, // TODO: fix type
    await graph.getDeployer(), graph.provider, {
        governor: taskArgs.skipPostDeploy ? undefined : (await graph.getNamedAccounts()).governor,
        forceDeploy: taskArgs.force,
        skipConfirmation: taskArgs.skipConfirmation,
        buildAcceptTx: taskArgs.buildAcceptTx,
    });
});
