"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MAX_PPM = void 0;
exports.createQueryDisputeID = createQueryDisputeID;
exports.encodeAttestation = encodeAttestation;
const ethers_1 = require("ethers");
exports.MAX_PPM = 1000000;
const { defaultAbiCoder: abi, arrayify, concat, hexlify, solidityKeccak256, joinSignature } = ethers_1.utils;
function createQueryDisputeID(attestation, indexerAddress, fishermanAddress) {
    return solidityKeccak256(['bytes32', 'bytes32', 'bytes32', 'address', 'address'], [
        attestation.requestCID,
        attestation.responseCID,
        attestation.subgraphDeploymentID,
        indexerAddress,
        fishermanAddress,
    ]);
}
function encodeAttestation(attestation) {
    const data = arrayify(abi.encode(['bytes32', 'bytes32', 'bytes32'], [attestation.requestCID, attestation.responseCID, attestation.subgraphDeploymentID]));
    const sig = joinSignature(attestation);
    return hexlify(concat([data, sig]));
}
