/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface DisputeManagerV1StorageInterface extends ethers.utils.Interface {
  functions: {
    "arbitrator()": FunctionFragment;
    "controller()": FunctionFragment;
    "disputes(bytes32)": FunctionFragment;
    "fishermanRewardPercentage()": FunctionFragment;
    "idxSlashingPercentage()": FunctionFragment;
    "minimumDeposit()": FunctionFragment;
    "qrySlashingPercentage()": FunctionFragment;
    "setController(address)": FunctionFragment;
    "syncAllContracts()": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "arbitrator",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "controller",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "disputes", values: [BytesLike]): string;
  encodeFunctionData(
    functionFragment: "fishermanRewardPercentage",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "idxSlashingPercentage",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "minimumDeposit",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "qrySlashingPercentage",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "setController",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "syncAllContracts",
    values?: undefined
  ): string;

  decodeFunctionResult(functionFragment: "arbitrator", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "controller", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "disputes", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "fishermanRewardPercentage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "idxSlashingPercentage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "minimumDeposit",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "qrySlashingPercentage",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "setController",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "syncAllContracts",
    data: BytesLike
  ): Result;

  events: {
    "ContractSynced(bytes32,address)": EventFragment;
    "ParameterUpdated(string)": EventFragment;
    "SetController(address)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "ContractSynced"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "ParameterUpdated"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "SetController"): EventFragment;
}

export type ContractSyncedEvent = TypedEvent<
  [string, string] & { nameHash: string; contractAddress: string }
>;

export type ParameterUpdatedEvent = TypedEvent<[string] & { param: string }>;

export type SetControllerEvent = TypedEvent<[string] & { controller: string }>;

export class DisputeManagerV1Storage extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: DisputeManagerV1StorageInterface;

  functions: {
    arbitrator(overrides?: CallOverrides): Promise<[string]>;

    controller(overrides?: CallOverrides): Promise<[string]>;

    disputes(
      arg0: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [string, string, BigNumber, string, number, number] & {
        indexer: string;
        fisherman: string;
        deposit: BigNumber;
        relatedDisputeID: string;
        disputeType: number;
        status: number;
      }
    >;

    fishermanRewardPercentage(overrides?: CallOverrides): Promise<[number]>;

    idxSlashingPercentage(overrides?: CallOverrides): Promise<[number]>;

    minimumDeposit(overrides?: CallOverrides): Promise<[BigNumber]>;

    qrySlashingPercentage(overrides?: CallOverrides): Promise<[number]>;

    setController(
      _controller: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    syncAllContracts(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;
  };

  arbitrator(overrides?: CallOverrides): Promise<string>;

  controller(overrides?: CallOverrides): Promise<string>;

  disputes(
    arg0: BytesLike,
    overrides?: CallOverrides
  ): Promise<
    [string, string, BigNumber, string, number, number] & {
      indexer: string;
      fisherman: string;
      deposit: BigNumber;
      relatedDisputeID: string;
      disputeType: number;
      status: number;
    }
  >;

  fishermanRewardPercentage(overrides?: CallOverrides): Promise<number>;

  idxSlashingPercentage(overrides?: CallOverrides): Promise<number>;

  minimumDeposit(overrides?: CallOverrides): Promise<BigNumber>;

  qrySlashingPercentage(overrides?: CallOverrides): Promise<number>;

  setController(
    _controller: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  syncAllContracts(
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  callStatic: {
    arbitrator(overrides?: CallOverrides): Promise<string>;

    controller(overrides?: CallOverrides): Promise<string>;

    disputes(
      arg0: BytesLike,
      overrides?: CallOverrides
    ): Promise<
      [string, string, BigNumber, string, number, number] & {
        indexer: string;
        fisherman: string;
        deposit: BigNumber;
        relatedDisputeID: string;
        disputeType: number;
        status: number;
      }
    >;

    fishermanRewardPercentage(overrides?: CallOverrides): Promise<number>;

    idxSlashingPercentage(overrides?: CallOverrides): Promise<number>;

    minimumDeposit(overrides?: CallOverrides): Promise<BigNumber>;

    qrySlashingPercentage(overrides?: CallOverrides): Promise<number>;

    setController(
      _controller: string,
      overrides?: CallOverrides
    ): Promise<void>;

    syncAllContracts(overrides?: CallOverrides): Promise<void>;
  };

  filters: {
    "ContractSynced(bytes32,address)"(
      nameHash?: BytesLike | null,
      contractAddress?: null
    ): TypedEventFilter<
      [string, string],
      { nameHash: string; contractAddress: string }
    >;

    ContractSynced(
      nameHash?: BytesLike | null,
      contractAddress?: null
    ): TypedEventFilter<
      [string, string],
      { nameHash: string; contractAddress: string }
    >;

    "ParameterUpdated(string)"(
      param?: null
    ): TypedEventFilter<[string], { param: string }>;

    ParameterUpdated(
      param?: null
    ): TypedEventFilter<[string], { param: string }>;

    "SetController(address)"(
      controller?: null
    ): TypedEventFilter<[string], { controller: string }>;

    SetController(
      controller?: null
    ): TypedEventFilter<[string], { controller: string }>;
  };

  estimateGas: {
    arbitrator(overrides?: CallOverrides): Promise<BigNumber>;

    controller(overrides?: CallOverrides): Promise<BigNumber>;

    disputes(arg0: BytesLike, overrides?: CallOverrides): Promise<BigNumber>;

    fishermanRewardPercentage(overrides?: CallOverrides): Promise<BigNumber>;

    idxSlashingPercentage(overrides?: CallOverrides): Promise<BigNumber>;

    minimumDeposit(overrides?: CallOverrides): Promise<BigNumber>;

    qrySlashingPercentage(overrides?: CallOverrides): Promise<BigNumber>;

    setController(
      _controller: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    syncAllContracts(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;
  };

  populateTransaction: {
    arbitrator(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    controller(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    disputes(
      arg0: BytesLike,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    fishermanRewardPercentage(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    idxSlashingPercentage(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    minimumDeposit(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    qrySlashingPercentage(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    setController(
      _controller: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    syncAllContracts(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;
  };
}
