/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  ethers,
  EventFilter,
  Signer,
  BigNumber,
  BigNumberish,
  PopulatedTransaction,
  BaseContract,
  ContractTransaction,
  Overrides,
  CallOverrides,
} from "ethers";
import { BytesLike } from "@ethersproject/bytes";
import { Listener, Provider } from "@ethersproject/providers";
import { FunctionFragment, EventFragment, Result } from "@ethersproject/abi";
import type { TypedEventFilter, TypedEvent, TypedListener } from "./common";

interface SubgraphAvailabilityManagerInterface extends ethers.utils.Interface {
  functions: {
    "NUM_ORACLES()": FunctionFragment;
    "acceptOwnership()": FunctionFragment;
    "checkVotes(bytes32,bool)": FunctionFragment;
    "currentNonce()": FunctionFragment;
    "executionThreshold()": FunctionFragment;
    "governor()": FunctionFragment;
    "lastAllowVote(uint256,bytes32,uint256)": FunctionFragment;
    "lastDenyVote(uint256,bytes32,uint256)": FunctionFragment;
    "oracles(uint256)": FunctionFragment;
    "pendingGovernor()": FunctionFragment;
    "setOracle(uint256,address)": FunctionFragment;
    "setVoteTimeLimit(uint256)": FunctionFragment;
    "transferOwnership(address)": FunctionFragment;
    "vote(bytes32,bool,uint256)": FunctionFragment;
    "voteMany(bytes32[],bool[],uint256)": FunctionFragment;
    "voteTimeLimit()": FunctionFragment;
  };

  encodeFunctionData(
    functionFragment: "NUM_ORACLES",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "acceptOwnership",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "checkVotes",
    values: [BytesLike, boolean]
  ): string;
  encodeFunctionData(
    functionFragment: "currentNonce",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "executionThreshold",
    values?: undefined
  ): string;
  encodeFunctionData(functionFragment: "governor", values?: undefined): string;
  encodeFunctionData(
    functionFragment: "lastAllowVote",
    values: [BigNumberish, BytesLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "lastDenyVote",
    values: [BigNumberish, BytesLike, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "oracles",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "pendingGovernor",
    values?: undefined
  ): string;
  encodeFunctionData(
    functionFragment: "setOracle",
    values: [BigNumberish, string]
  ): string;
  encodeFunctionData(
    functionFragment: "setVoteTimeLimit",
    values: [BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "transferOwnership",
    values: [string]
  ): string;
  encodeFunctionData(
    functionFragment: "vote",
    values: [BytesLike, boolean, BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "voteMany",
    values: [BytesLike[], boolean[], BigNumberish]
  ): string;
  encodeFunctionData(
    functionFragment: "voteTimeLimit",
    values?: undefined
  ): string;

  decodeFunctionResult(
    functionFragment: "NUM_ORACLES",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "acceptOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "checkVotes", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "currentNonce",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "executionThreshold",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "governor", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "lastAllowVote",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "lastDenyVote",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "oracles", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "pendingGovernor",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "setOracle", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "setVoteTimeLimit",
    data: BytesLike
  ): Result;
  decodeFunctionResult(
    functionFragment: "transferOwnership",
    data: BytesLike
  ): Result;
  decodeFunctionResult(functionFragment: "vote", data: BytesLike): Result;
  decodeFunctionResult(functionFragment: "voteMany", data: BytesLike): Result;
  decodeFunctionResult(
    functionFragment: "voteTimeLimit",
    data: BytesLike
  ): Result;

  events: {
    "NewOwnership(address,address)": EventFragment;
    "NewPendingOwnership(address,address)": EventFragment;
    "OracleSet(uint256,address)": EventFragment;
    "OracleVote(bytes32,bool,uint256,uint256)": EventFragment;
    "VoteTimeLimitSet(uint256)": EventFragment;
  };

  getEvent(nameOrSignatureOrTopic: "NewOwnership"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "NewPendingOwnership"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "OracleSet"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "OracleVote"): EventFragment;
  getEvent(nameOrSignatureOrTopic: "VoteTimeLimitSet"): EventFragment;
}

export type NewOwnershipEvent = TypedEvent<
  [string, string] & { from: string; to: string }
>;

export type NewPendingOwnershipEvent = TypedEvent<
  [string, string] & { from: string; to: string }
>;

export type OracleSetEvent = TypedEvent<
  [BigNumber, string] & { index: BigNumber; oracle: string }
>;

export type OracleVoteEvent = TypedEvent<
  [string, boolean, BigNumber, BigNumber] & {
    subgraphDeploymentID: string;
    deny: boolean;
    oracleIndex: BigNumber;
    timestamp: BigNumber;
  }
>;

export type VoteTimeLimitSetEvent = TypedEvent<
  [BigNumber] & { voteTimeLimit: BigNumber }
>;

export class SubgraphAvailabilityManager extends BaseContract {
  connect(signerOrProvider: Signer | Provider | string): this;
  attach(addressOrName: string): this;
  deployed(): Promise<this>;

  listeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter?: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): Array<TypedListener<EventArgsArray, EventArgsObject>>;
  off<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  on<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  once<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeListener<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>,
    listener: TypedListener<EventArgsArray, EventArgsObject>
  ): this;
  removeAllListeners<EventArgsArray extends Array<any>, EventArgsObject>(
    eventFilter: TypedEventFilter<EventArgsArray, EventArgsObject>
  ): this;

  listeners(eventName?: string): Array<Listener>;
  off(eventName: string, listener: Listener): this;
  on(eventName: string, listener: Listener): this;
  once(eventName: string, listener: Listener): this;
  removeListener(eventName: string, listener: Listener): this;
  removeAllListeners(eventName?: string): this;

  queryFilter<EventArgsArray extends Array<any>, EventArgsObject>(
    event: TypedEventFilter<EventArgsArray, EventArgsObject>,
    fromBlockOrBlockhash?: string | number | undefined,
    toBlock?: string | number | undefined
  ): Promise<Array<TypedEvent<EventArgsArray & EventArgsObject>>>;

  interface: SubgraphAvailabilityManagerInterface;

  functions: {
    NUM_ORACLES(overrides?: CallOverrides): Promise<[BigNumber]>;

    acceptOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    checkVotes(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      overrides?: CallOverrides
    ): Promise<[boolean]>;

    currentNonce(overrides?: CallOverrides): Promise<[BigNumber]>;

    executionThreshold(overrides?: CallOverrides): Promise<[BigNumber]>;

    governor(overrides?: CallOverrides): Promise<[string]>;

    lastAllowVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    lastDenyVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<[BigNumber]>;

    oracles(arg0: BigNumberish, overrides?: CallOverrides): Promise<[string]>;

    pendingGovernor(overrides?: CallOverrides): Promise<[string]>;

    setOracle(
      _index: BigNumberish,
      _oracle: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    setVoteTimeLimit(
      _voteTimeLimit: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    transferOwnership(
      _newGovernor: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    vote(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    voteMany(
      _subgraphDeploymentID: BytesLike[],
      _deny: boolean[],
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<ContractTransaction>;

    voteTimeLimit(overrides?: CallOverrides): Promise<[BigNumber]>;
  };

  NUM_ORACLES(overrides?: CallOverrides): Promise<BigNumber>;

  acceptOwnership(
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  checkVotes(
    _subgraphDeploymentID: BytesLike,
    _deny: boolean,
    overrides?: CallOverrides
  ): Promise<boolean>;

  currentNonce(overrides?: CallOverrides): Promise<BigNumber>;

  executionThreshold(overrides?: CallOverrides): Promise<BigNumber>;

  governor(overrides?: CallOverrides): Promise<string>;

  lastAllowVote(
    arg0: BigNumberish,
    arg1: BytesLike,
    arg2: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  lastDenyVote(
    arg0: BigNumberish,
    arg1: BytesLike,
    arg2: BigNumberish,
    overrides?: CallOverrides
  ): Promise<BigNumber>;

  oracles(arg0: BigNumberish, overrides?: CallOverrides): Promise<string>;

  pendingGovernor(overrides?: CallOverrides): Promise<string>;

  setOracle(
    _index: BigNumberish,
    _oracle: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  setVoteTimeLimit(
    _voteTimeLimit: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  transferOwnership(
    _newGovernor: string,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  vote(
    _subgraphDeploymentID: BytesLike,
    _deny: boolean,
    _oracleIndex: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  voteMany(
    _subgraphDeploymentID: BytesLike[],
    _deny: boolean[],
    _oracleIndex: BigNumberish,
    overrides?: Overrides & { from?: string | Promise<string> }
  ): Promise<ContractTransaction>;

  voteTimeLimit(overrides?: CallOverrides): Promise<BigNumber>;

  callStatic: {
    NUM_ORACLES(overrides?: CallOverrides): Promise<BigNumber>;

    acceptOwnership(overrides?: CallOverrides): Promise<void>;

    checkVotes(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      overrides?: CallOverrides
    ): Promise<boolean>;

    currentNonce(overrides?: CallOverrides): Promise<BigNumber>;

    executionThreshold(overrides?: CallOverrides): Promise<BigNumber>;

    governor(overrides?: CallOverrides): Promise<string>;

    lastAllowVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    lastDenyVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    oracles(arg0: BigNumberish, overrides?: CallOverrides): Promise<string>;

    pendingGovernor(overrides?: CallOverrides): Promise<string>;

    setOracle(
      _index: BigNumberish,
      _oracle: string,
      overrides?: CallOverrides
    ): Promise<void>;

    setVoteTimeLimit(
      _voteTimeLimit: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    transferOwnership(
      _newGovernor: string,
      overrides?: CallOverrides
    ): Promise<void>;

    vote(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      _oracleIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    voteMany(
      _subgraphDeploymentID: BytesLike[],
      _deny: boolean[],
      _oracleIndex: BigNumberish,
      overrides?: CallOverrides
    ): Promise<void>;

    voteTimeLimit(overrides?: CallOverrides): Promise<BigNumber>;
  };

  filters: {
    "NewOwnership(address,address)"(
      from?: string | null,
      to?: string | null
    ): TypedEventFilter<[string, string], { from: string; to: string }>;

    NewOwnership(
      from?: string | null,
      to?: string | null
    ): TypedEventFilter<[string, string], { from: string; to: string }>;

    "NewPendingOwnership(address,address)"(
      from?: string | null,
      to?: string | null
    ): TypedEventFilter<[string, string], { from: string; to: string }>;

    NewPendingOwnership(
      from?: string | null,
      to?: string | null
    ): TypedEventFilter<[string, string], { from: string; to: string }>;

    "OracleSet(uint256,address)"(
      index?: BigNumberish | null,
      oracle?: string | null
    ): TypedEventFilter<
      [BigNumber, string],
      { index: BigNumber; oracle: string }
    >;

    OracleSet(
      index?: BigNumberish | null,
      oracle?: string | null
    ): TypedEventFilter<
      [BigNumber, string],
      { index: BigNumber; oracle: string }
    >;

    "OracleVote(bytes32,bool,uint256,uint256)"(
      subgraphDeploymentID?: BytesLike | null,
      deny?: null,
      oracleIndex?: BigNumberish | null,
      timestamp?: null
    ): TypedEventFilter<
      [string, boolean, BigNumber, BigNumber],
      {
        subgraphDeploymentID: string;
        deny: boolean;
        oracleIndex: BigNumber;
        timestamp: BigNumber;
      }
    >;

    OracleVote(
      subgraphDeploymentID?: BytesLike | null,
      deny?: null,
      oracleIndex?: BigNumberish | null,
      timestamp?: null
    ): TypedEventFilter<
      [string, boolean, BigNumber, BigNumber],
      {
        subgraphDeploymentID: string;
        deny: boolean;
        oracleIndex: BigNumber;
        timestamp: BigNumber;
      }
    >;

    "VoteTimeLimitSet(uint256)"(
      voteTimeLimit?: null
    ): TypedEventFilter<[BigNumber], { voteTimeLimit: BigNumber }>;

    VoteTimeLimitSet(
      voteTimeLimit?: null
    ): TypedEventFilter<[BigNumber], { voteTimeLimit: BigNumber }>;
  };

  estimateGas: {
    NUM_ORACLES(overrides?: CallOverrides): Promise<BigNumber>;

    acceptOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    checkVotes(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    currentNonce(overrides?: CallOverrides): Promise<BigNumber>;

    executionThreshold(overrides?: CallOverrides): Promise<BigNumber>;

    governor(overrides?: CallOverrides): Promise<BigNumber>;

    lastAllowVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    lastDenyVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<BigNumber>;

    oracles(arg0: BigNumberish, overrides?: CallOverrides): Promise<BigNumber>;

    pendingGovernor(overrides?: CallOverrides): Promise<BigNumber>;

    setOracle(
      _index: BigNumberish,
      _oracle: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    setVoteTimeLimit(
      _voteTimeLimit: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    transferOwnership(
      _newGovernor: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    vote(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    voteMany(
      _subgraphDeploymentID: BytesLike[],
      _deny: boolean[],
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<BigNumber>;

    voteTimeLimit(overrides?: CallOverrides): Promise<BigNumber>;
  };

  populateTransaction: {
    NUM_ORACLES(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    acceptOwnership(
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    checkVotes(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    currentNonce(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    executionThreshold(
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    governor(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    lastAllowVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    lastDenyVote(
      arg0: BigNumberish,
      arg1: BytesLike,
      arg2: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    oracles(
      arg0: BigNumberish,
      overrides?: CallOverrides
    ): Promise<PopulatedTransaction>;

    pendingGovernor(overrides?: CallOverrides): Promise<PopulatedTransaction>;

    setOracle(
      _index: BigNumberish,
      _oracle: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    setVoteTimeLimit(
      _voteTimeLimit: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    transferOwnership(
      _newGovernor: string,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    vote(
      _subgraphDeploymentID: BytesLike,
      _deny: boolean,
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    voteMany(
      _subgraphDeploymentID: BytesLike[],
      _deny: boolean[],
      _oracleIndex: BigNumberish,
      overrides?: Overrides & { from?: string | Promise<string> }
    ): Promise<PopulatedTransaction>;

    voteTimeLimit(overrides?: CallOverrides): Promise<PopulatedTransaction>;
  };
}
